<template>
    <div id="alert-logs" class="content">
        <div class="header">
            <h2>Alert Logs</h2>
        </div>
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class='wrapper'>
                        <tabs @change="switchTab($event)">
                            <!-- DPNR Tab -->
                            <tab name="DPNR" title="DPNR">
                                <div class="mt-2 mb-3">
                                    <div class="d-flex flex-md-row flex-column align-items-center justify-content-between">
                                        <per-page :per-page="pagination.per_page" @change="changeLimit($event, 'Dpnr', 'DPNR')"></per-page>

                                        <div class="d-flex flex-column flex-md-row align-items-center mt-3 mt-md-0">
                                            <div class="d-flex">
                                                <button class="download btn btn-fluid text-uppercase btn-reset" type="submit" @click="downloadToCSV">
                                                    Download To CSV
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <vuetable ref="dpnrTable"
                                    :api-mode="false"
                                    :css="tableClass"
                                    :data="tableData"
                                    :data-manager="dataManager"
                                    :fields="tableFields"
                                ></vuetable>

                                <div class="pagination ui basic segment grid d-flex flex-column flex-md-row justify-content-between">
                                    <vuetable-pagination-info ref="paginationInfoDpnr"></vuetable-pagination-info>

                                    <vuetable-pagination ref="paginationDpnr" class="mt-4 mt-md-0"
                                        @vuetable-pagination:change-page="changePage($event, 'Dpnr', 'DPNR')"
                                    ></vuetable-pagination>
                                </div>
                            </tab>

                            <!-- ENR-25 Tab -->
                            <tab name="ENR-25" title="ENR-25">
                                <div class="mt-2 mb-3">
                                    <div class="d-flex flex-md-row flex-column align-items-center justify-content-between">
                                        <per-page :per-page="pagination.per_page" @change="changeLimit($event, 'Enr25', 'ENR-25')"></per-page>

                                        <div class="d-flex flex-column flex-md-row align-items-center mt-3 mt-md-0">
                                            <div class="d-flex">
                                                <button class="download btn btn-fluid text-uppercase btn-reset" type="submit" @click="downloadToCSV">
                                                    Download To CSV
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <vuetable ref="enr25Table"
                                    :api-mode="false"
                                    :css="tableClass"
                                    :data="tableData"
                                    :data-manager="dataManager"
                                    :fields="tableFields"
                                ></vuetable>

                                <div class="pagination ui basic segment grid">
                                    <vuetable-pagination-info ref="paginationInfoEnr25"></vuetable-pagination-info>

                                    <vuetable-pagination ref="paginationEnr25"
                                        @vuetable-pagination:change-page="changePage($event, 'Enr25', 'ENR-25')"
                                    ></vuetable-pagination>
                                </div>
                            </tab>

                            <!-- ENR-50 Tab -->
                            <tab name="ENR-50" title="ENR-50">
                                <div class="mt-2 mb-3">
                                    <div class="d-flex flex-md-row flex-column align-items-center justify-content-between">
                                        <per-page :per-page="pagination.per_page" @change="changeLimit($event, 'Enr50', 'ENR-50')"></per-page>

                                        <div class="d-flex flex-column flex-md-row align-items-center mt-3 mt-md-0">
                                            <div class="d-flex">
                                                <button class="download btn btn-fluid text-uppercase btn-reset" type="submit" @click="downloadToCSV">
                                                    Download To CSV
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <vuetable ref="enr50Table"
                                    :api-mode="false"
                                    :css="tableClass"
                                    :data="tableData"
                                    :data-manager="dataManager"
                                    :fields="tableFields"
                                ></vuetable>

                                <div class="pagination ui basic segment grid">
                                    <vuetable-pagination-info ref="paginationInfoEnr50"></vuetable-pagination-info>

                                    <vuetable-pagination ref="paginationEnr50"
                                        @vuetable-pagination:change-page="changePage($event, 'Enr50', 'ENR-50')"
                                    ></vuetable-pagination>
                                </div>
                            </tab>
                        </tabs>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import Tabs from '../../components/tab/Tabs';
import Tab from '../../components/tab/Tab';
import PerPage from '../../components/table/PerPage';
import AlertService from "@/services/AlertService";

// Import DayJS. Alternative to moment js. Better performance compare to moment.
import dayjs from 'dayjs';

export default {
    components: {
        Tabs,
        Tab,
        PerPage
    },
    data() {
        return {
            activeTab: 'DPNR',
            tableClass: {
                tableClass: 'ui striped table',
                ascendingIcon: 'icon-down-open',
                descendingIcon: 'icon-up-open',
                sortableIcon: 'icon-sort',
            },
            tableFields: [
                {
                    name: 'alertType',
                    title: 'Type',
                    formatter(value) {
                        return value[0].toUpperCase() + value.slice(1);
                    }
                },
                {
                    name: 'deviceId',
                    title: 'Device ID',
                },
                {
                    name: 'title',
                    title: 'Title',
                },
                {
                    name: 'message',
                    title: 'Message',
                },
                {
                    name: 'timestamp',
                    title: 'Time',
                    sortField: 'createdTimestamp',
                    formatter(value) {
                        return dayjs(value).format('HH:mm DD-MM-YYYY');
                    }
                },
            ],
            tableData: [],
            pagination: {
                total: 0,
                per_page: 25,
                current_page: 1,
                last_page: 0,
                from: 0,
                to: 0,
            }
        }
    },
    methods: {
        /**
         * Show loading overlay.
         */
        showLoadingOverlay() {
            this.$JsLoadingOverlay.show({'spinnerIcon': 'ball-scale-multiple'});
        },

        /**
         * Hide loading overlay.
         */
        hideLoadingOverlay() {
            this.$JsLoadingOverlay.hide();
        },

        /**
         * Function to be execute when you change limit of data per page.
         *
         * @param event
         */
        changeLimit(event, ref, productID) {
            this.showLoadingOverlay();

            // Update the page limit.
            this.pagination.per_page = event.target.value;

            // Get alert data.
            // The page number need to be 0 because page number in API start from 0.
            // When you change limit per page, the page number will be reset to first page.
            this.alertService.getAlertData(0, this.pagination.per_page, productID).then((response) => {
                this.tableData = response.data.alerts;

                this.setPaginationData(response.data.total, 1);

                // Update Vuetable-2 pagination data component.
                this.$refs['pagination' + ref].setPaginationData(this.pagination);
                this.$refs['paginationInfo' + ref].setPaginationData(this.pagination);

                this.hideLoadingOverlay();
            });

        },

        /**
         * Function to be execute when you change the page from the vue table.
         *
         * 'reference' parameter will be used to update pagination info. It will let Vue know in which tab
         * Vue should update.
         *
         * 'productId' parameter will be used by AlertService to retrieve alert logs data for specific tab.
         * AlertService will pass the productId to the API.
         * Available productID
         * - DPNR
         * - ENR-25
         * - ENR-50
         *
         * @param pageNumber
         * @param reference
         * @param productId
         */
        changePage(pageNumber, reference, productId) {
            this.showLoadingOverlay();

            // VueTable2 will return page number as 'next' or 'prev' when you click next page or previous page button.
            // Need to convert into the page number.
            if (pageNumber === 'next') {
                pageNumber = this.pagination.current_page + 1;
            } else if (pageNumber === 'prev') {
                pageNumber = this.pagination.current_page - 1;
            }

            // Get alert data.
            // The page number need to subtract 1 because page number in API start from 0.
            this.alertService.getAlertData((pageNumber - 1), this.pagination.per_page, productId).then((response) => {
                this.tableData = response.data.alerts;

                this.setPaginationData(response.data.total, pageNumber);

                // Update Vuetable-2 pagination data component.
                this.$refs['pagination' + reference].setPaginationData(this.pagination);
                this.$refs['paginationInfo' + reference].setPaginationData(this.pagination);

                this.hideLoadingOverlay();
            });
        },

        dataManager(sortOrder, pagination) {
            console.log(sortOrder, pagination);
        },

        /**
         * Export alert logs data to CSV.
         */
        downloadToCSV() {
            this.showLoadingOverlay();

            var headers = {
                id: 'ID',
                type: "Type",
                device: "Device",
                title: "Title",
                message: "Message",
                date: "Date",
            };

            this.alertService.getAlertData(this.pagination.current_page - 1, this.pagination.per_page, this.activeTab).then((response) => {
                let csvData = [];
                let csvFileName = 'Alert-Logs-' + dayjs().format('DD-MMM-YYYY_hh:mmA') + '.csv';

                response.data.alerts.forEach((alert) => {
                    csvData.push({
                        id: alert.id,
                        type: alert.alertType,
                        device: alert.deviceId,
                        title: alert.title,
                        message: alert.message,
                        date: dayjs(alert.timestamp).format('YYYY-MM-DD HH:mm:ss'),
                    })
                });

                // Add header.
                csvData.unshift(headers);

                // Convert Object to JSON
                let csvJson = JSON.stringify(csvData);

                let blob = new Blob([this.convertJsonToCSVText(csvJson)], {type: 'text/csv;charset=utf-8;'});

                if (navigator.msSaveBlob) { // IE 10+
                    navigator.msSaveBlob(blob, csvFileName);
                } else {
                    let link = document.createElement("a");

                    if (link.download !== undefined) {
                        // Browsers that support HTML5 download attribute
                        var url = URL.createObjectURL(blob);
                        link.setAttribute("href", url);
                        link.setAttribute("download", csvFileName);
                        link.style.visibility = 'hidden';
                        document.body.appendChild(link);
                        link.click();
                        document.body.removeChild(link);
                    }
                }
            })
            .finally(() => this.hideLoadingOverlay());
        },

        convertJsonToCSVText(jsonObject) {
            let array = typeof jsonObject != 'object' ? JSON.parse(jsonObject) : jsonObject;
            let str = '';

            for (let i = 0; i < array.length; i++) {
                let line = '';

                for (let index in array[i]) {
                    if (line != '') line += ','

                    line += array[i][index];
                }

                str += line + '\r\n';
            }

            return str;
        },

        /**
         * Set pagination data.
         * API only return total of record available.
         * Need to calculate pagination data manually.
         *
         * @param total
         * @param pageNumber
         */
        setPaginationData(total, pageNumber = 1) {
            this.pagination.current_page = pageNumber;
            this.pagination.total = total;
            this.pagination.last_page = Math.ceil(total / this.pagination.per_page);
            this.pagination.from = Math.ceil((this.pagination.current_page * this.pagination.per_page) - (this.pagination.per_page - 1));

            if (pageNumber === this.pagination.last_page) {
                this.pagination.to = total;
            } else {
                this.pagination.to = Math.ceil(this.pagination.current_page * this.pagination.per_page);
            }
        },

        /**
         * Set VueTable-2 pagination component.
         * When you switch tab bwtween DPNR, ENR-25, ENR50, Vue need to reset and update the pagination data.
         * To update the pagination data, Vue need to know in which tab Vue need to update the pagination data.
         */
        setPaginationComponentReference(productID) {
            // Set reference for Vuetable-2 pagination component.
            if (productID === 'DPNR') {
                return 'Dpnr'
            } else if (productID === 'ENR-25') {
                return 'Enr25'
            } else {
                return 'Enr50'
            }
        },

        /**
         * Switch tab between DPNR, ENR-25 and ENR-50.
         * When you switch tab, Vue will request the API to retrieve alert logs data based on the productID.
         *
         * 'productId' parameter will be used by AlertService to retrieve alert logs data for specific tab.
         * AlertService will pass the productId to the API.
         * Available productID
         * - DPNR
         * - ENR-25
         * - ENR-50
         */
        switchTab(productId) {
            this.activeTab = productId;
            this.showLoadingOverlay();

            // Get alert data.
            // The page number need to subtract 1 because page number in API start from 0.
            this.alertService.getAlertData(this.pagination.current_page - 1, this.pagination.per_page, productId).then((response) => {
                this.tableData = response.data.alerts;

                let ref = this.setPaginationComponentReference(productId);

                this.setPaginationData(response.data.total, 1);

                // Update Vuetable-2 pagination data component.
                this.$refs['pagination' + ref].setPaginationData(this.pagination);
                this.$refs['paginationInfo' + ref].setPaginationData(this.pagination);
            })
            .finally(() => this.hideLoadingOverlay());
        }
    },
    computed: {
        /**
         * Create AlertService instance.
         *
         * @returns {AlertService}
         */
        alertService: function () {
            return new AlertService();
        }
    },
    mounted() {
        this.showLoadingOverlay();

        // Get alert data.
        this.alertService.getAlertData(this.pagination.current_page - 1, this.pagination.per_page)
        .then((response) => {
            this.tableData = response.data.alerts;

            this.setPaginationData(response.data.total, 1);

            this.$refs.paginationDpnr.setPaginationData(this.pagination);
            this.$refs.paginationInfoDpnr.setPaginationData(this.pagination);
        })
        .finally(() => this.hideLoadingOverlay());
    }
}
</script>

<style lang="scss" scoped>
.per-page {
    width: 50%;
}

input[type=text] {
    width: 65%;
}

.btn {
    margin: 0 0 0 1rem;
    padding: 0.8rem 1rem;

    &.btn-search {
        background: $green;
    }
}
</style>
